( convert sector order )

$100 constant sector

: sectors sector * ;

$10 sectors constant track

: tracks track * ;

create physical_order
$0 , $1 , $2 , $3 , $4 , $5 , $6 , $7 , $8 , $9 , $a , $b , $c , $d , $e , $f ,

create dos33_order
$0 , $7 , $e , $6 , $d , $5 , $c , $4 , $b , $3 , $a , $2 , $9 , $1 , $8 , $f ,

create prodos_order
$0 , $8 , $1 , $9 , $2 , $a , $3 , $b , $4 , $c , $5 , $d , $6 , $e , $7 , $f ,

: find-sector ( number order -- index )
  $10 $0 ?do 2dup i cells + @ = if i leave then loop nip nip ;

: lookup-sector ( index order -- number )
  swap cells + @ ;

: convert-sector ( fromnumber fromorder toorder -- tonumber )
  >r find-sector r> lookup-sector ;

: copy-sector ( fromaddress fromsegment tonumber fromorder toorder -- )
  swap convert-sector sectors rot + sector rot copy-range ;

: copy-track { fromaddress fromsegment fromorder toorder -- }
  $10 $0 ?do
    fromaddress fromsegment i fromorder toorder copy-sector
  loop ;

: copy-floppy { fromaddress fromsegment fromorder toorder -- }
  fromaddress $23 tracks + fromaddress ?do
    i fromsegment fromorder toorder copy-track
  track +loop ;

